import { CollectionBase, MultipleSelection, Node, SelectionMode, Sortable, SortDescriptor } from "@react-types/shared";
import { GridState } from "@react-stately/grid";
import { TableCollection, TableHeaderProps, TableBodyProps, ColumnProps, RowProps, CellProps } from "@react-types/table";
import { Key } from "react";
export interface TableState<T> extends GridState<T, TableCollection<T>> {
    collection: TableCollection<T>;
    showSelectionCheckboxes: boolean;
    sortDescriptor: SortDescriptor;
    sort(columnKey: Key): void;
}
export interface CollectionBuilderContext<T> {
    showSelectionCheckboxes: boolean;
    selectionMode: SelectionMode;
    columns: Node<T>[];
}
export interface TableStateProps<T> extends CollectionBase<T>, MultipleSelection, Sortable {
    showSelectionCheckboxes?: boolean;
}
export function useTableState<T extends object>(props: TableStateProps<T>): TableState<T>;
export let TableHeader: <T>(props: TableHeaderProps<T>) => JSX.Element;
export let TableBody: <T>(props: TableBodyProps<T>) => JSX.Element;
export let Column: <T>(props: ColumnProps<T>) => JSX.Element;
export let Row: <T>(props: RowProps<T>) => JSX.Element;
export let Cell: (props: CellProps) => JSX.Element;
export { Section } from '@react-stately/collections';

//# sourceMappingURL=types.d.ts.map
